package javax.annotation.processing;

import javax.lang.model.element.ExecutableElement;
import javax.lang.model.element.AnnotationMirror;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.lang.model.SourceVersion;
import java.util.Set;

public interface Processor
{
    public abstract Set<String> getSupportedOptions();
    
    public abstract Set<String> getSupportedAnnotationTypes();
    
    public abstract SourceVersion getSupportedSourceVersion();
    
    public abstract void init(ProcessingEnvironment p0);
    
    public abstract boolean process(Set<? extends TypeElement> p0, RoundEnvironment p1);
    
    public abstract Iterable<? extends Completion> getCompletions(Element p0, AnnotationMirror p1, ExecutableElement p2, String p3);
}
